# Generated by Django 4.1.7 on 2023-05-29 11:49

import uuid

import django.db.models.deletion
import enumfields.fields
from django.contrib.postgres.operations import CreateExtension
from django.db import migrations, models

import arkindex.project.aws
import arkindex.project.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        CreateExtension("postgis"),
        migrations.CreateModel(
            name="Image",
            fields=[
                ("id", models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ("created", models.DateTimeField(auto_now_add=True)),
                ("updated", models.DateTimeField(auto_now=True)),
                ("path", arkindex.project.fields.LStripTextField(chars="/")),
                ("width", models.PositiveIntegerField(default=0)),
                ("height", models.PositiveIntegerField(default=0)),
                ("hash", arkindex.project.fields.MD5HashField(blank=True, max_length=32, null=True)),
                ("status", enumfields.fields.EnumField(default="unchecked", enum=arkindex.project.aws.S3FileStatus, max_length=50)),
            ],
            bases=(arkindex.project.aws.S3FileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="ImageServer",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("display_name", models.CharField(max_length=250)),
                ("url", arkindex.project.fields.StripSlashURLField(unique=True)),
                ("s3_bucket", models.SlugField(blank=True, db_index=False, max_length=63, null=True)),
                ("s3_region", models.SlugField(blank=True, db_index=False, max_length=63, null=True)),
                ("s3_read_only_bucket", models.BooleanField(default=False, help_text="Disable the extra image checks that are normally made for servers with S3 buckets.")),
                ("max_width", models.PositiveIntegerField(blank=True, null=True)),
                ("max_height", models.PositiveIntegerField(blank=True, null=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
                ("updated", models.DateTimeField(auto_now=True)),
            ],
        ),
        migrations.AddConstraint(
            model_name="imageserver",
            constraint=models.CheckConstraint(check=models.Q(("s3_read_only_bucket", False), ("s3_bucket__isnull", False), _connector="OR"), name="s3_read_only_bucket_requires_s3_bucket"),
        ),
        migrations.AddField(
            model_name="image",
            name="server",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="images", to="images.imageserver"),
        ),
        migrations.AddConstraint(
            model_name="image",
            constraint=models.CheckConstraint(check=models.Q(models.Q(("height__gt", 0), ("width__gt", 0)), models.Q(("status", arkindex.project.aws.S3FileStatus["Checked"]), _negated=True), _connector="OR"), name="checked_image_dimensions"),
        ),
        migrations.AlterUniqueTogether(
            name="image",
            unique_together={("server", "hash"), ("server", "path")},
        )
    ]
